using System;
using System.Collections;
using System.Data;
using System.Data.OleDb;
using System.Text;
using System.Xml;
using Gregor.Cgi;

namespace Gregor.Cgi.Media {

internal class CKeyInfo : IRenderable, INamedValue {

    private string m_Name;

    public CKeyInfo(XmlElement xe) {
        m_Name = xe.Attributes["name"].Value;
    }

    public string Name{
        get{
            return m_Name;
        }
    }

    public string Renderer{
        get{
            return "Gregor.Cgi.Media.CKeyRenderer";
        }
    }

    public IRenderer GetRenderer(){
        return new CKeyRenderer(this);
    }

    public string GetValue(){
        string s = CEnv.GetQueryParam(this.Name);
        if(s != null){
            s = CHelper.HexUnEscape(s);
        }
        return s;
    }

} // class CKeyInfo

internal class CKeyRenderer : IRenderer {

    private CKeyInfo m_Key;

    public CKeyRenderer(CKeyInfo key) {
        m_Key = key;
    }

    public CKeyInfo Key{
        get{
            return m_Key;
        }
    }

    public void Render(CRenderingContext context){
        string sValue = this.Key.GetValue();
        COut.WriteHtmlHiddenField(this.Key.Name, sValue);
    }

} // class CKeyRenderer

} // namespace Gregor.Cgi.Media