using System;
using System.Collections;
using System.Data;
using System.Data.OleDb;
using System.Text;
using System.Xml;
using Gregor.Cgi;

namespace Gregor.Cgi.Media {

internal class CLinkInfo : CRenderableBase {

    private string m_ToPage;
    private string m_ToColumn;

    public CLinkInfo(XmlElement xe) : base(xe){
        m_ToPage = xe.Attributes["to-page"].Value;
        m_ToColumn = xe.Attributes["to-column"].Value;
    }

    public string ToPage{
        get{
            return m_ToPage;
        }
    }

    public string ToColumn{
        get{
            return m_ToColumn;
        }
    }

} // class CLinkInfo

internal class CLinkRenderer : IRenderer {

    private CLinkInfo m_Link;

    public CLinkRenderer(CLinkInfo link){
        m_Link = link;
    }

    public CLinkInfo Link{
        get{
            return m_Link;
        }
    }

    public void Render(CRenderingContext context){
        string s = null;
        string sColValue = CEnv.GetQueryParam(this.Link.ToColumn);
        if(this.Link.ToPage.Equals("special")){
            s = CHelper.CreateSpecialLink(this.Link.Title, this.Link.ToColumn);
        }else{
            s = CHelper.CreatePageLink(this.Link.Title, this.Link.ToPage, this.Link.ToColumn, sColValue);
        }
        COut.W(s);
    }

} // class CLinkRenderer

} // namespace Gregor.Cgi.Media